
*** Example code that shows how the MCI class can be used
*** Note error handling is minimal and file names are hardcoded.
*** I suggest you test each of these blocks individually and
*** look over the code *before* running them.


*** MCICD SAMPLE
IF .F.
   oCD=createobject("MCICd")
   
   ? oCD.open()

   ? oCD.mciCommand("info","Product")
   ? oCd.GetTimeFormat()
   ? oCd.play("02:01:00")
   ? oCd.GetTimeFormat()
   
   wait window "Press any key to stop..."
     
 *  ? oCd.SetTimeFormat("MILLISECONDS")
   DO Showstats with oCD
   
   ? oCd.SetTimeFormat("TRACK AND TIME")
   DO Showstats with oCD
  

   
   ? oCD.pause()
wait window "Press any key to resume..."

   ? oCD.play()
   
   *** RESUME does not appear to work!!!
   *? oCD.MCICommand("resume","")
   *? oCD.resume
   
wait window "Press any key to go to track 5 at 1 minute"   

   
   ? oCD.play("05:01:00")

   DO SHOWSTATS with oCD
   
   ? "Current Track",oCD.mciCommand("Status","Current Track") 
   ? "Length of Track",oCD.mciCommand("Status","Length  Track 1") 
   ? "Current Position",oCD.mciCommand("Status","position") 
   ? "Number of tracks",oCD.mciCommand("Status","Number of Tracks") 
   ? "Total Length",oCD.mciCommand("Status","Length") 

wait window "Any key for Track 2 1 minute, 20"
   
   ? oCD.Play("02:01:20")

   ? oCd.SetTimeFormat("MILLISECONDS")

   ? oCD.MCICommand("Status","time format")
   ? "Current Track",oCD.mciCommand("Status","Current Track") 
   ? "Length of Track",oCD.mciCommand("Status","Length  Track 1") 
   ? "Current Position",oCD.mciCommand("Status","position") 
   ? "Number of tracks",oCD.mciCommand("Status","Number of Tracks") 
   ? "Total Length",oCD.mciCommand("Status","Length") 
 
wait window "Press any key to quit..."
   
   ? oCD.close()
   RETURN
ENDIF


*** MCIWAV SAMPLE
IF .F.
   *** MCIWave Sample Code
   lcFileName="rage.wav"

   oWave=createobject("MCIWave",lcFileName)
   
   oWave.play
   
   wait window timeout 5 "Playing 5 seconds..."
   do showstats with oWave

   oWave.SetTimeFormat("SAMPLES")
   do showstats with oWave

   oWave.SetTimeFormat()   && MILLISECONDS
   
       
   oWave.Pause
   wait window timeout 2 "Pausing 2 seconds..."
   
   oWave.Resume
   wait window nowait "Resuming until finished..."
   
   *** Play until done
   DO WHILE inkey()=0 .and. oWave.GetTrackPosition()<oWave.nTracklength
   ENDDO
   
   oWave.Close
ENDIF

IF .F.
   *** MCIWave Recording Sample Code
*   lcFileName="C:\windows\system\chunks.wav"
*  lcFileName="e:\test.wav"

   *** Don't specify a filename - manually use OpenForRecording
   *** instead   
   oWave=createobject("MCIWave")

   ? oWave.OpenForRecording(lcFilename)
   
   lcRetVal=oWave.record()
   oWave.MCIErrorString(lcRetVal)
   
   wait window timeout 5 "Playing 5 seconds..."
   do showstats with oWave

   oWave.Pause
   wait window timeout 2 "Pausing 2 seconds..."
   
   oWave.Resume
   wait window  "Press any key to save..."
   
   do showstats with oWave
   
   oWave.Stop
   oWave.save() 

   oWave.Close
ENDIF

*** PLAYWAV SAMPLE
IF .T.
   *** MCIWave Sample Code
   lcFileName="rage.wav"
   oWave=createobject("MCIWave",lcFileName)
   
   oWave.playwav
   wait window "Press [Y]es to stop wave file, or any other key to keep going in background" TO Temp
   IF upper(temp)="Y"
      *** Kill sound 
      oWave.playwav(4)
   ENDIF
   
ENDIF


*** MCIVideo Sample code
IF .F.
   clear
   lcVideoFile="welcome1.avi"
   
   oForm=createobject("Form")
   oform.caption="MCI Window"
   oForm.left=100
   oform.top=100
   oForm.show
   ACTIVATE SCREEN
   
   oVideo=createobject("MCIVideo")
   
   *** Open in VFP window
   ? oVideo.open(lcVideoFile,oForm.caption)
    
   
   *** Open in own window
   *? oVideo.open(lcVideoFile)
   
   ? oVideo.play()
   wait window "Playing 4 secs..." TIMEOUT 4

   ? oVideo.settimeformat("MS")
   DO ShowStats with oVideo
   
   *** Resize the Window to full window size
   ? oVideo.pause()
   wait window "Pausing 2 secs..." timeout 2
   
   ? oVideo.setsize(0,0,oForm.width,oform.height)
   
   STORE 0 TO lnLeft,lnTop,lnHeight,lnWidth
   ? oVideo.getsize(@lnWidth,@lnHeight)
   ? "Current sizes: ",lnWidth,lnHeight
   
   ? oVideo.resume()
   wait window "Zooming image and resuming for 4 seconds..." timeout 4
   
   *** Now resize window again
   ? oVideo.setsize(10,10,150,150)
   
   ? oVideo.getsize(@lnWidth,@lnHeight)
   ? "Current sizes: ",lnWidth,lnHeight
   
   ? oVideo.play(100)
   
   wait window "Resized and starting at position 100 of " + str(oVideo.nTrackLength) 
   
   DO ShowStats with oVideo
   
   *? oVideo.Close()  && not necessary - automatic when out of scope
ENDIF

RETURN


************************************************************************
PROCEDURE ShowStats
******************
***  Function: Status Display Function
************************************************************************
PARAMETER oSource

   lnTrack=oSource.GetTrack()
   ? "Display Format",oSource.GetTimeFormat()
   ? "Current Track",lnTrack,"of",oSource.GetTracks()
   ? "Track Position",oSource.GetTrackPosition()
   ? "Track Length",oSource.GetTrackLength(lnTrack)
   ? "Total Length",oSource.GetLength()

RETURN
*EOP ShowStats
